// 003 u_parse_dfm
// 04 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_parse_dfm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl
  ;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    exit_: TButton;
    clear_: TButton;
    display_object_list_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure display_object_list_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_strings, u_stringlist

      , u_c_dfm_scanner
      , u_c_dfm_parser
      , u_c_dfm_object
      ;

    {$R *.DFM}

  
    
    const k_initial_directory= '..\_data\';
            k_extension= '.pas';
            k_file_name= 'pascal.pas';

    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;
        g_file_count: Integer= 0;
        g_ok_file_count: Integer= 0;

        g_c_dfm_object: c_dfm_object= Nil;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      var l_c_dfm_scanner: c_dfm_scanner;
      begin
        g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;

        Inc(g_file_count);

        display('  '+ p_file_name);
        Inc(g_ok_file_count);

        l_c_dfm_scanner:= c_dfm_scanner.create_dfm_scanner('scan', p_path+ p_file_name);
        // l_c_dfm_scanner.test_dfm_scanner;

        g_c_dfm_object.Free;

        with c_dfm_parser.create_dfm_parser('parser') do
        begin
          m_c_dfm_scanner_ref:= l_c_dfm_scanner;
          m_c_dfm_object:= g_c_dfm_object;

          // m_trace_parser:= True;
          // m_c_dfm_scanner_ref.m_display_symbol_read:= True;
          // m_pure_parsing:= True;
          m_c_dfm_object_list_ref:= c_dfm_object_list.create_dfm_object_list('obj');

          parse_dfm;
          g_c_dfm_object:= m_c_dfm_object;

          Free;
        end; // with c_dfm_scanner
      end; // my_call_back

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_directory_listbox_directory(DirectoryListBox1, k_initial_directory);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        display_path_and_file;
      end; // DirectoryListBox1Change

    // -- call handler

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      var l_path, l_name: String;
      begin
        l_path:= DirectoryListBox1.Directory;
        with FileListbox1 do
          l_name:= Items[ItemIndex];

        g_file_count:= 0;
        my_call_back(0, l_path+ '\', l_name, Nil);
      end; // FileListBox1Click

    procedure TForm1.display_object_list_Click(Sender: TObject);
      begin
        Caption:= 'p_parse_dfm';
        with g_c_dfm_object do
          display_dfm_object_tree;
      end; // display_object_list_Click


end.


