// 001 i_dfm_parser
// 05 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

PROCEDURE parse_dfm;

  PROCEDURE parse_object(p_c_dfm_parent_object: c_dfm_object);

    PROCEDURE parse_property(p_c_dfm_object, p_c_dfm_tree_object: c_dfm_object);
      var l_c_dfm_property: c_dfm_property;
          l_c_dfm_tree_property: c_dfm_property;

      PROCEDURE parse_value;

        procedure parse_collection_item;
          var l_c_collection_item_list: c_dfm_object_list;
              l_c_collection_item: c_dfm_object;
          begin
            display_trace('> collection_item');
            // -- here after "<"
            // l_c_dfm_tree_property.m_c_collection:= c_collection.create_collection('coll');
            l_c_collection_item_list:= c_dfm_object_list.create_dfm_object_list('coll_obj_list');
            l_c_dfm_tree_property.m_c_dfm_collection_object_list:= l_c_collection_item_list;

            while f_symbol_type<> e_greater_symbol do
            begin
              check(e_IDENTIFIER_symbol);
              // l_c_item_property_list:= l_c_dfm_tree_property.m_c_collection.f_c_add_item(f_symbol_string);
              l_c_collection_item:= l_c_collection_item_list.f_c_add_dfm_object('item');
              l_c_collection_item.m_object_name:= f_symbol_string;
              l_c_collection_item.m_is_collection:= True;

              read_symbol;
              while f_symbol_type<> e_end_symbol do
              begin
                parse_property(p_c_dfm_object, l_c_collection_item);
              end; // while f_symbol_type<> e_end_symbol

              // -- skip "end"
              read_symbol;
            end; // while f_symbol_type<> greater_symbol

            // -- skip >
            read_symbol;
            display_trace('< collection_item');
          end; // parse_collection_item

        var l_value: String;

        BEGIN // parse_value
          display_trace('> value');

          with l_c_dfm_property do
            CASE f_symbol_type OF
              e_INTEGER_symbol :
                  begin
                    add_unique_value(f_symbol_string);
                    update_property_type(e_integer_symbol);

                    l_c_dfm_tree_property.add_value(f_symbol_string);
                    read_symbol;
                  end;
              e_DOUBLE_symbol :
                  begin
                    add_unique_value(f_symbol_string);
                    update_property_type(e_double_symbol);

                    l_c_dfm_tree_property.add_value(f_symbol_string);
                    read_symbol;
                  end;
              e_TRUE_symbol :
                  begin
                    add_unique_value(f_symbol_string);
                    update_property_type(e_TRUE_symbol);

                    l_c_dfm_tree_property.add_value(f_symbol_string);
                    read_symbol;
                  end;
              e_FALSE_symbol :
                  begin
                    add_unique_value(f_symbol_string);
                    update_property_type(e_TRUE_symbol);

                    l_c_dfm_tree_property.add_value(f_symbol_string);
                    read_symbol;
                  end;

              e_STRING_litteral_symbol :
                  begin
                    add_unique_value(f_symbol_string);
                    update_property_type(e_string_litteral_symbol);

                    l_c_dfm_tree_property.add_value(f_symbol_string);
                    read_symbol;

                    // -- "Hint = 'aha' + 'other'"
                    WHILE f_symbol_type= e_plus_symbol do
                    BEGIN
                      if f_symbol_type= e_plus_symbol
                        then read_symbol;
                      parse_value;
                    END; // WHILE {
                  end;

              e_identifier_symbol :
                  begin
                    l_value:= f_symbol_string;
                    l_c_dfm_tree_property.add_value(l_value);
                    read_symbol;

                    WHILE f_symbol_type= e_point_symbol DO
                    BEGIN
                      // display('.name '+ l_value);
                      read_symbol;
                      check(e_IDENTIFIER_symbol);
                      l_value:= l_value+ '.'+ f_symbol_string;
                      l_c_dfm_tree_property.add_value('.');
                      l_c_dfm_tree_property.add_value(f_symbol_string);

                      read_symbol;
                    END; // IF [

                    add_unique_value(l_value);
                    update_property_type(e_identifier_symbol);
                  end;

              e_opening_bracket_symbol :
                  BEGIN
                    m_is_set:= true;
                    l_c_dfm_tree_property.m_is_set:= True;
                    read_symbol;

                    // m_trace_parser:= True;
                    if f_symbol_type<> e_closing_bracket_symbol
                      then begin
                          parse_value;
                          WHILE f_symbol_type= e_comma_symbol DO
                          BEGIN
                            read_symbol;
                            parse_value;
                          END; // WHILE {
                        end;
                    // m_trace_parser:= False;

                    check(e_closing_bracket_symbol);
                    read_symbol;
                  END; // n

              e_lower_symbol :
                  begin
                    l_c_dfm_tree_property.m_is_collection:= True;

                    read_symbol;
                    parse_collection_item;
                  end;
              e_opening_parenthesis_symbol :
                  BEGIN
                    l_c_dfm_tree_property.m_is_list:= True;
                    read_symbol;

                    parse_value;

                    WHILE f_symbol_type IN [e_plus_symbol,
                        e_INTEGER_symbol, e_DOUBLE_symbol, e_TRUE_symbol, e_FALSE_symbol, e_STRING_litteral_symbol,
                        e_identifier_symbol,
                        e_opening_bracket_symbol, e_opening_parenthesis_symbol, e_opening_brace_symbol] DO
                    BEGIN
                      // display('while');
                      if f_symbol_type= e_plus_symbol
                        then read_symbol;
                      parse_value;
                    END; // WHILE {

                    // display('end_of_value '+ f_dfm_symbol_name(f_symbol_type));
                    check(e_closing_parenthesis_symbol);
                    read_symbol;
                  END; // n
              e_opening_brace_symbol :
                  BEGIN
                    read_symbol;
                    l_c_dfm_tree_property.m_has_brace:= True;

                    parse_value;
                    WHILE f_symbol_type IN [e_INTEGER_symbol, e_DOUBLE_symbol, e_TRUE_symbol, e_FALSE_symbol, e_STRING_litteral_symbol,
                        e_identifier_symbol,
                        e_opening_bracket_symbol, e_opening_parenthesis_symbol, e_opening_brace_symbol] DO
                      parse_value;
                    check(e_closing_brace_symbol);
                    read_symbol;
                  END; // n
              ELSE display_error('INTEGER, DOUBLE, TRUE, FALSE, STRING, [, (, {, <');
            END; // case

          display_trace('< value');
        END; // parse_value

      var l_property_name: String;
          l_c_dfm_sub_object: c_dfm_object;

      BEGIN // parse_property
        display_trace('> property');
        check(e_IDENTIFIER_symbol);
        l_property_name:= f_symbol_string;
        read_symbol;

        IF f_symbol_type= e_point_symbol
          THEN BEGIN
              l_c_dfm_tree_property:= Nil;

              // display('prop .NAME');
              WHILE f_symbol_type= e_point_symbol DO
              BEGIN
                read_symbol;
                check(e_IDENTIFIER_symbol);
                // -- the sub-object
                l_c_dfm_sub_object:= m_c_dfm_object_list_ref.f_c_add_unique_dfm_object(l_property_name);
                // -- add the .xxx as the sub-property of this object
                l_c_dfm_property:= l_c_dfm_sub_object.m_c_dfm_property_list.f_c_add_unique_dfm_property(f_symbol_string);

                if l_c_dfm_tree_property= Nil
                  then l_c_dfm_tree_property:= p_c_dfm_tree_object.m_c_dfm_property_list.f_c_add_dfm_property(l_property_name);
                // force_display('add_.NAME '+ f_symbol_string);
                l_c_dfm_tree_property.add_name(f_symbol_string);

                // -- add the sub-object as a property of the main object
                // l_c_dfm_property:= p_c_dfm_object.m_c_dfm_property_list.f_c_add_unique_dfm_property(f_symbol_string);
                with p_c_dfm_object.m_c_dfm_property_list.f_c_add_unique_dfm_property(l_property_name) do
                begin
                  // display('add_sub '+ f_symbol_string);
                  add_unique_value('c_'+ f_symbol_string);
                  update_property_type(e_class_symbol);
                end;

                // -- add the property and its value
                // l_property_name:= l_property_name+ '.'+ f_symbol_string;
                // -- skip the identifier
                read_symbol;
              END; // WHILE f_symbol_type= e_point_symbol

              // with l_c_dfm_tree_property do
              //  force_display(l_property_name+ '|'+ f_replace_return_with_bar(m_c_name_list.Text));
              check(e_equal_symbol);
              read_symbol;
              parse_value;
            END // IF [
          else begin
              l_c_dfm_property:= p_c_dfm_object.m_c_dfm_property_list.f_c_add_unique_dfm_property(l_property_name);

              l_c_dfm_tree_property:= p_c_dfm_tree_object.m_c_dfm_property_list.f_c_add_dfm_property(l_property_name);

              check(e_equal_symbol);
              read_symbol;
              parse_value;
            end;
        display_trace('< property');
      END; // parse_property

    var l_object_identifier: String;
        l_c_dfm_object: c_dfm_object;
        l_c_tree_dfm_object: c_dfm_object;

    BEGIN // parse_object
      display_trace('> object');
      check(e_OBJECT_symbol);
      read_symbol;
      check(e_IDENTIFIER_symbol);
      l_object_identifier:= f_symbol_string;
      read_symbol;
      check(e_colon_symbol);
      read_symbol;
      check(e_IDENTIFIER_symbol);
      // -- add to the list of ALL objects, saving the object TYPE (not the name)
      if m_c_dfm_object_list_ref= Nil
        then display('m_c_dfm_object_list_ref= Nil');
      l_c_dfm_object:= m_c_dfm_object_list_ref.f_c_add_unique_dfm_object(f_symbol_string);

      // -- create the node in this dfm's tree, saving the object NAME
      if p_c_dfm_parent_object= Nil
        then begin
            // -- create the root
            // display('  add_root');
            m_c_dfm_object:= c_dfm_object.create_dfm_object(f_symbol_string);
            l_c_tree_dfm_object:= m_c_dfm_object;
          end
        else begin
            // display('  add_child');
            l_c_tree_dfm_object:= p_c_dfm_parent_object.m_c_dfm_object_list_.f_c_add_dfm_object(f_symbol_string);
          end;
      l_c_tree_dfm_object.m_object_name:= l_object_identifier;

      read_symbol;

      // -- the properties
      IF f_symbol_type= e_IDENTIFIER_symbol
        THEN BEGIN
            parse_property(l_c_dfm_object, l_c_tree_dfm_object);
            WHILE f_symbol_type= e_IDENTIFIER_symbol DO
              parse_property(l_c_dfm_object, l_c_tree_dfm_object);
          END; // 2

      // -- recurse
      while f_symbol_type= e_OBJECT_symbol do
        parse_object(l_c_tree_dfm_object);

      check(e_END_symbol);
      read_symbol;
      display_trace('< object');
    END; // parse_object

  BEGIN // parse_dfm
    display_trace('> dfm');
    parse_object(Nil);
    display_trace('< dfm');
  END; // parse_dfm
